/*
 * This file is part of the SPiC Project SPiChess  (https://gitlab.cs.fau.de/i4/spic/chess).
 * Copyright (c) 2017 - 2020 by Bernhard Heinloth
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHESS_DISPLAY_H
#define CHESS_DISPLAY_H

#include <stdint.h>
#include <stdbool.h>

#include "board.h"

void display_intro();
void display_playerMenu(int8_t player);
void display_playerMenuSelect(int8_t value);
void display_status(const char* str);
void display_statusFromFlash(const __flash char* str);
void display_board();
void display_field(uint8_t y, uint8_t x, bool highlight);
void display_selected();
void display_move(int8_t player, uint8_t move);
#endif
